<?php

	$db=$_GET["db"];

	include("xor_helper.php");
	include("xor_perms.php");
	include("xor_treedata.php");
	include("xor_tasks.php");

	if (!$HTTP_RAW_POST_DATA)
	{
		echo "<html><head><title>Error - No Data</title></head><body>";
		echo "<h1>Error - No Data</h1>Raw XML (text/xml) must be supplied as a POST request in order to use this URL.</body>";
		exit;
	}

	Header("Content-type: text/xml");
   Header("Connection: Close");

	# create the Q&A DOMs
	$question=domxml_open_mem($HTTP_RAW_POST_DATA);
	$question_root=$question->document_element();
	$answer=domxml_open_mem("<Answer/>");
	$answer_root=$answer->document_element();
	
	# pull some basic information from the question node
	$type="";
	$host="";
	$username="";
	$password="";
	
	$node=find_child($question_root,"ID");
	
	$node=$node->first_child();
	while ($node) 
	{
		#echo $node->node_name() . "=[" . get_text($node) . "]\n";
		
		if ($node->node_name()=="Type") $type=get_text($node);
		else if ($node->node_name()=="Host") $host=get_text($node);
		else if ($node->node_name()=="Username") $username=get_text($node);
		else if ($node->node_name()=="Password") $password=get_text($node);
		$node=$node->next_sibling();
	}
	
	# create the ID nodes
	$id_node=$answer_root->new_child("ID","");
	$id_node->new_child("Type",$type);
	$id_node->new_child("Host",$host);
	
	# initialise the data node
	$data_node=$answer_root->new_child("Data","");

	# connect to database, validate username/password
	db_connect();
	perms_validate($username,$password);
	
	# the authenticate question is special
	if ($type=="Authenticate") 
	{
		q_authenticate();
		db_disconnect();
		echo $answer->dumpmem();
		return;
	}
		
	
	if (!perms_enabled())
	{
		add_error("Permission to access the Realm is denied. Invalid username/password, or account disabled.");
		db_disconnect();
		echo $answer->dumpmem();
		return;
	}

	# now consider all the possible questions...

	if ($type=="Wakeup") q_wakeup();
	if ($type=="Shutdown") q_shutdown();
	if ($type=="Ping") q_ping();
	if ($type=="HardReload") q_hardreload();
	if ($type=="Tree") q_tree();
	if ($type=="Data") q_data();
	if ($type=="Submit") q_submit();
	if ($type=="NewContainer") q_new_container();
	if ($type=="NewObject") q_new_object();
	if ($type=="NewCollection") q_new_collection();
	if ($type=="NewProperty") q_new_property();
	if ($type=="Delete") q_delete();
	if ($type=="Rename") q_rename();
	if ($type=="FetchBranch") q_fetchbranch();
	if ($type=="AppendBranch") q_appendbranch();
	
	if ($type=="PermListUsers") q_perm_listusers();
	if ($type=="PermListGroups") q_perm_listgroups();
	if ($type=="PermFetchUser") q_perm_fetchuser();
	if ($type=="PermSetPassword") q_perm_setpassword();
	if ($type=="PermAddUser") q_perm_adduser();
	if ($type=="PermRenameUser") q_perm_renameuser();
	if ($type=="PermRemoveUser") q_perm_removeuser();
	if ($type=="PermEnableUser") q_perm_enableuser();
	if ($type=="PermJoinGroup") q_perm_joingroup();
	if ($type=="PermAddGroup") q_perm_addgroup();
	if ($type=="PermRenameGroup") q_perm_renamegroup();
	if ($type=="PermRemoveGroup") q_perm_removegroup();
	
	if ($type=="TaskList") q_task_list();
	if ($type=="TaskFetch") q_task_fetch();
	if ($type=="TaskNew") q_task_new();
	if ($type=="TaskDelete") q_task_delete();
	if ($type=="TaskClaim") q_task_claim();
	if ($type=="TaskCancel") q_task_cancel();
	if ($type=="TaskComplete") q_task_complete();
	if ($type=="TaskPause") q_task_pause();
	if ($type=="TaskTick") q_task_tick();
	if ($type=="TaskPriority") q_task_priority();
	if ($type=="TaskChangePath") q_task_changepath();

	# disconnect & output the final results
	db_disconnect();	
	echo $answer->dumpmem();
	
?>
