<?php

## Helper Functions
##
## General purpose useage for Xortoth
##
## The main PHP page should include this file at the beginning;
## other included files may assume that this has been included
## beforehand.

function find_child($node,$child_name)
{
	$sub_node=$node->first_child();
	while ($sub_node)
	{
		if ($sub_node->node_name()==$child_name) return $sub_node;
		$sub_node=$sub_node->next_sibling();
	}
	return $subnode; # i.e. null
}

function find_grandchild($node,$child_name,$grandchild_name)
{
	$subnode=find_child($node,$child_name);
	if (!$subnode) return $subnode;
	$subnode=find_child($subnode,$grandchild_name);
	return $subnode;
}

function get_text($node)
{
	#$text_node=array_shift($node->children());
	#return $text_node->content;
	
	$text_node=$node->first_child();
	if ($text_node) return $text_node->get_content(); else return "";
}

function grandchild_or_error($node,$child_name,$grandchild_name)
{
	$subnode=find_grandchild($node,$child_name,$grandchild_name);
	if (!$subnode) {add_error("$child_name/$grandchild_name not supplied."); return "@";}
	return get_text($subnode);
}

function add_error($message)
{
	global $answer_root;

	$error_node=find_child($answer_root,"Errors");
	if (!$error_node) $error_node=$answer_root->new_child("Errors");
	$error_node->new_child("Err",$message);
}

function find_tree_path($path)
{
	$query="SELECT Key_Tree FROM Tree WHERE Key_Parent IS NULL";
	$result=mysql_query($query);
	if (mysql_numrows($result)<1) 
	{
		add_error("Tree parent record not found.");
		return 0;
	}
	$key_tree=mysql_result($result,0,"Key_Tree");

	if ($path=="/") return $key_tree;

	$resid=substr($path,1);

	while (1)
	{
		if (ereg("^(.*)[\/\:](.*)$",$resid,$regs)) 
		{
			$piece=$regs[1]; 
			$resid=$regs[2];
			# unfortunate due to greedy regexes
			while (ereg("^(.*)[\/\:](.*)$",$piece,$regs)) {$piece=$regs[1]; $resid=$regs[2] . ":$resid";}
		} 
		else {$piece=$resid; $resid="";}
		if ($piece=="") break;

		$query="SELECT Key_Tree FROM Tree WHERE Key_Parent=$key_tree AND Name='$piece'";
		$result=mysql_query($query);
		if (mysql_numrows($result)<1) 
		{
			add_error("Unable to locate Tree fragment: $piece");
			return 0;
		}
		$key_tree=mysql_result($result,0,"Key_Tree");

		#echo "\n{{$piece}:{$query}:{$key_tree}}\n\n";
	}
	return $key_tree;
}

function find_data_path($path)
{
	if (ereg("^(.*):(.*)$",$path,$regs)) {$tree_path=$regs[1]; $data_path=$regs[2];} else return 0;

	$key_tree=find_tree_path($tree_path);
	if ($key_tree<1) return 0;

	$query="SELECT Key_Data FROM Data WHERE Key_Parent=$key_tree AND Name='$data_path'";
	$result=mysql_query($query);
	if (mysql_numrows($result)<1) return 0;

	return mysql_result($result,0,"Key_Data");
}

function sql_text($text)
{
	return ereg_replace("\'","''",$text);
}

function clean_text($text)
{
	while (ereg("(.*)[\ \\\/\`\~\!\@\#\$\%\^\&\*\(\)\+\=\,\<\>\;\:\'\"\?\{\}\|](.*)",$text,$regs))
		{$text=$regs[1].$regs[2];}
	return $text;
}

function db_list()
{
	$data_list=file("datasources");
	if (!$data_list) {return array();}
	
	$ret_array=array();
	foreach($data_list as $datum)
	{
		if (!ereg("^\\#",$datum)) if (ereg("(.*)\\,(.*)\\,(.*)\\,(.*)",$datum,$regs))
		{
			$ret_array[count($ret_array)+1]=$regs[3];
		}
	}
	return $ret_array;
}

function db_connect()
{
	global $db;
	
	$data_list=file("datasources");
	if (!$data_list) die("ERROR: datasources file not found.");
	
	foreach($data_list as $datum)
	{
		if (!ereg("^\\#",$datum)) if (ereg("(.*)\\,(.*)\\,(.*)\\,(.*)",trim($datum),$regs))
		{
			if (strcasecmp($regs[3],$db)==0 || strlen($db)==0)
			{
				$dbusername=$regs[1];
				$dbpassword=$regs[2];
				$database=$regs[3];
				$dbhost=$regs[4];
				break;
			}
		}
	}
	
	if (!$database) die("Unable to discover database from datasources file.");
	
	mysql_connect($dbhost,$dbusername,$dbpassword);
	@mysql_select_db($database) or die("Unable to select database");	
}

function db_disconnect()
{
	mysql_close();
}

?>
