<?php

## Permission Functions
##
## Specific user validation, and handling questions related to permissions.
##
## The main PHP page should include this file at the beginning;
## other included files may assume that this has been included
## beforehand.

function perms_validate($username,$password)
{
	global $perms_username,$perms_enabled,$perms_superuser;
	
	$perms_username=$username;
	$perms_enabled=false;
	$perms_superuser=false;
	
	$query="SELECT Type,Enabled,Password FROM Perms WHERE ID='".sql_text($perms_username)."'";
	
	$result=mysql_query($query);
	$num=mysql_numrows($result);
	
	if ($num==0) return;

	$type=mysql_result($result,0,"Type");
	$enabled=mysql_result($result,0,"Enabled");
	$lpassword=mysql_result($result,0,"Password");
	
	if ($type=="SuperUser") $perms_superuser=true;
	else if ($type!="User") return;
	
	if ($enabled!="Y") return;
	
	if (strlen($lpassword)>0)
	{
		if ($lpassword!=$password) return;
	}
	
	$perms_enabled=true;
}

function perms_enabled() 
{
	global $perms_enabled;
	return $perms_enabled;
}

function perms_superuser() 
{
	global $perms_superuser;
	return $perms_superuser;
}

function q_authenticate()
{
	global $question_root,$data_node,$perms_username;

	$data_node->new_child("Username",$perms_username);

	if (perms_enabled()) 
	{
		$data_node->new_child("Enabled","True");
		
		$query="UPDATE Perms SET LastUse=NOW() WHERE ID='".sql_text($perms_username)."'";
		$result=mysql_query($query);
	}
	else $data_node->new_child("Enabled","False");

	if (perms_enabled() && perms_superuser()) $data_node->new_child("SuperUser","True");
		else $data_node->new_child("SuperUser","False");
}

function q_perm_listusers()
{
	global $question_root,$data_node;

	if (!perms_superuser()) {add_error("Listing of users is only available to superusers."); return;}
	
	$query="SELECT ID,Description,Type,LastUse FROM Perms WHERE Type='User' OR Type='SuperUser'";
	
	$result=mysql_query($query);
	$num=mysql_numrows($result);
	
	for($n=0;$n<$num;$n++)
	{
		$node=$data_node->new_child("User","");
		$node->new_child("Username",mysql_result($result,$n,"ID"));
		$node->new_child("Description",mysql_result($result,$n,"Description"));
		$superuser="False"; if (mysql_result($result,$n,"Type")=="SuperUser") $superuser="True";
		$node->new_child("SuperUser",$superuser);
		$node->new_child("LastUse",mysql_result($result,$n,"LastUse"));
	}	
}

function q_perm_listgroups()
{
	global $question_root,$data_node,$perms_username;
	
	$query="SELECT ID,Description FROM Perms WHERE Type='Group'";
	
	$result=mysql_query($query);
	$num=mysql_numrows($result);
	
	for($n=0;$n<$num;$n++)
	{
		$name=mysql_result($result,$n,"ID");
		
		if (perms_superuser() || member_of_group($perms_username,$name))
		{
			$groupnode=$data_node->new_child("Group","");
			$groupnode->new_child("Groupname",$name);
			$groupnode->new_child("Description",mysql_result($result,$n,"Description"));

			$query="SELECT Subordinate FROM Perms WHERE Type='Member' AND ID='".sql_text($name)."'";
			$subresult=mysql_query($query);
			$subnum=mysql_numrows($subresult);
			for($i=0;$i<$subnum;$i++)
			{
				$groupnode->new_child("Member",mysql_result($subresult,$i,"Subordinate"));
			}
		}
	}	
}

function q_perm_fetchuser()
{
	global $question_root,$data_node,$perms_username;	
	
	$user_node=find_grandchild($question_root,"Data","Username");
	if (!$user_node) {add_error("Data/Username node not supplied."); return;}
	$username=get_text($user_node);
	
	if (!perms_superuser() && $username!=$perms_username)
	{
		add_error("Non-superusers may only fetch user information about themselves.");
		return;
	}
	
	$query="SELECT * FROM Perms WHERE (Type='User' OR Type='SuperUser') AND ID='".sql_text($username)."'";
	
	$result=mysql_query($query);
	if (mysql_numrows($result)==0)
	{
		add_error("Unable to fetch user, not found.");
	}
	
	$data_node->new_child("Username",mysql_result($result,0,"ID"));
	$data_node->new_child("Description",mysql_result($result,0,"Description"));
	$superuser="False"; if (mysql_result($result,0,"Type")=="SuperUser") $superuser="True";
	$data_node->new_child("SuperUser",$superuser);
	$data_node->new_child("LastUse",mysql_result($result,0,"LastUse"));
	$enabled="False"; if (mysql_result($result,0,"Enabled")=="Y") $enabled="True";
	$data_node->new_child("Enabled",$enabled);
}

function q_perm_setpassword()
{
	global $question_root,$data_node,$perm_username;
	
	$user_node=find_grandchild($question_root,"Data","Username");
	if (!$user_node) {add_error("Data/Username node not supplied."); return;}
	$username=get_text($user_node);
	$pass_node=find_grandchild($question_root,"Data","NewPassword");
	if (!$pass_node) {add_error("Data/Password node not supplied."); return;}
	$password=get_text($pass_node);
	$conf_node=find_grandchild($question_root,"Data","OldPassword");
	if ($conf_node) $confirm=get_text($conf_node); else $confirm="";
	
	$query="SELECT Password FROM Perms WHERE (Type='User' OR Type='SuperUser') AND ID='".sql_text($username)."'";
	$result=mysql_query($query);
	if (mysql_numrows($result)==0) {add_error("Unable to fetch user, not found."); return;}
	$old_password=mysql_result($result,0,"Password");
	
	if (!perms_superuser())
	{
		if ($username!=$perm_username) {add_error("Non-superusers can only change their own passwords."); return;}
		
		if (strlen($old_password)>0)
		{
			if (strlen($confirm)==0) {add_error("Data/ConfirmPassword must be supplied, by non-superusers."); return;}
			if ($password!=$old_password) {add_error("Confirmation password does not match current password."); return;}
		}
	}
	
	$query="UPDATE Perms SET Password='".sql_text($password)."' WHERE (Type='User' OR Type='SuperUser') AND ID='".sql_text($username)."'";
	mysql_query($query);
	
	$data_node->new_child("Success");
}

function q_perm_adduser()
{
	global $question_root,$data_node;
	
	if (!perms_superuser()) {add_error("Must be superuser to add a user."); return;}
	
	$user_node=find_grandchild($question_root,"Data","Username");
	if (!$user_node) {add_error("Data/Username node not supplied."); return;}
	$username=get_text($user_node);
	if (strlen($username)==0) {add_error("Username is blank!"); return;}
	$descr_node=find_grandchild($question_root,"Data","Description");
	if (!$descr_node) {add_error("Data/Description node not supplied."); return;}
	$description=get_text($descr_node);
	$pass_node=find_grandchild($question_root,"Data","Password");
	if (!$pass_node) {add_error("Data/Password node not supplied."); return;}
	$password=get_text($pass_node);
	$super_node=find_grandchild($question_root,"Data","SuperUser");
	$type='User';
	if (get_text($super_node)=="True") $type='SuperUser';

	$query="SELECT * FROM Perms WHERE (Type='User' OR Type='SuperUser') AND ID='".sql_text($username)."'";
	$result=mysql_query($query);
	if (mysql_numrows($result)>0) {add_error("Cannot add user, already exists!"); return;}

	$query="INSERT INTO Perms (ID,Description,Password,Type,Enabled) VALUES ('".
		    sql_text($username)."','".sql_text($description)."','".sql_text($password)."','".
			 $type."','Y')";
	mysql_query($query);

	$data_node->new_child("Success");
}

function q_perm_removeuser()
{
	global $question_root,$data_node;	

	if (!perms_superuser()) {add_error("Must be superuser to remove a user."); return;}

	$user_node=find_grandchild($question_root,"Data","Username");
	if (!$user_node) {add_error("Data/Username node not supplied."); return;}
	$username=get_text($user_node);
	if (strlen($username)==0) {add_error("Username is blank!"); return;}

	$query="SELECT * FROM Perms WHERE (Type='User' OR Type='SuperUser') AND ID='".sql_text($username)."'";
	$result=mysql_query($query);
	if (mysql_numrows($result)==0) {add_error("User does not exist."); return;}
	
	$query="DELETE FROM Perms WHERE (Type='User' OR Type='SuperUser') AND ID='".sql_text($username)."'";
	mysql_query($query);

	$data_node->new_child("Success");
}

function q_perm_enableuser()
{
	global $question_root,$data_node;
	
	if (!perms_superuser()) {add_error("Must be superuser to enabled/disable a user."); return;}
	
	$user_node=find_grandchild($question_root,"Data","Username");
	if (!$user_node) {add_error("Data/Username node not supplied."); return;}
	$username=get_text($user_node);
	if (strlen($username)==0) {add_error("Username is blank!"); return;}

	$enable_node=find_grandchild($question_root,"Data","Enabled");
	if (!$enable_node) {add_error("Data/Enabled node not supplied."); return;}
	$enable_text=get_text($enable_node);
	if ($enable_text=="True") $enable_text='Y';
	else if ($enable_text=="False") $enable_text='N';
	else {add_error("Data/Enabled must be set to True or False."); return;}
	
	$query="SELECT * FROM Perms WHERE (Type='User' OR Type='SuperUser') AND ID='".sql_text($username)."'";
	$result=mysql_query($query);
	if (mysql_numrows($result)==0) {add_error("User does not exist."); return;}

	$query="UPDATE Perms SET Enabled='$enable_text' WHERE (Type='User' OR Type='SuperUser') AND ID='".sql_text($username)."'";
	mysql_query($query);
	
	$data_node->new_child("Success");	
}

function q_perm_joingroup()
{
	global $question_root,$data_node;	
	
	if (!perms_superuser()) {add_error("Must be superuser to join/unjoin a group."); return;}
	
	$user_node=find_grandchild($question_root,"Data","Username");
	if (!$user_node) {add_error("Data/Username node not supplied."); return;}
	$username=get_text($user_node);
	if (strlen($username)==0) {add_error("Username is blank!"); return;}
	$group_node=find_grandchild($question_root,"Data","Groupname");
	if (!$group_node) {add_error("Data/Groupname node not supplied."); return;}
	$groupname=get_text($group_node);
	if (strlen($groupname)==0) {add_error("Groupname is blank!"); return;}

	$join_node=find_grandchild($question_root,"Data","Joined");
	if (!$join_node) {add_error("Data/Joined node not supplied."); return;}
	$joined=get_text($join_node);
	
	$query="SELECT * FROM Perms WHERE Type='Group' AND ID='".sql_text($groupname)."'";
	$result=mysql_query($query);
	if (mysql_numrows($result)==0) {add_error("Group does not exist!"); return;}
	
	if ($joined=="True")
	{
		$query="SELECT * FROM Perms WHERE Type='Member' AND ID='".sql_text($groupname)."' AND Subordinate='".sql_text($username)."'";
		$result=mysql_query($query);
		if (mysql_numrows($result)>0) {add_error("User is already a member of the group."); return;}

		$query="INSERT INTO Perms (Type,ID,Subordinate) VALUES ('Member','".sql_text($groupname)."','".sql_text($username)."')";
		mysql_query($query);
	}
	else if ($joined=="False")
	{
		$query="SELECT * FROM Perms WHERE Type='Member' AND ID='".sql_text($groupname)."' AND Subordinate='".sql_text($username)."'";
		$result=mysql_query($query);
		if (mysql_numrows($result)==0) {add_error("User is not in the group."); return;}
		
		$query="DELETE FROM Perms WHERE Type='Member' AND ID='".sql_text($groupname)."' AND Subordinate='".sql_text($username)."'";
		mysql_query($query);
	}
	else {add_error("Data/Joined node must be True or False."); return;}
	
	$data_node->new_child("Success");		
}

function q_perm_addgroup()
{
	global $question_root,$data_node;	
	
	if (!perms_superuser()) {add_error("Must be superuser to add a group."); return;}
	
	$group_node=find_grandchild($question_root,"Data","Groupname");
	if (!$group_node) {add_error("Data/Groupname node not supplied."); return;}
	$groupname=get_text($group_node);
	if (strlen($groupname)==0) {add_error("Groupname is blank!"); return;}
	$descr_node=find_grandchild($question_root,"Data","Description");
	if (!$descr_node) {add_error("Data/Description node not supplied."); return;}
	$description=get_text($descr_node);

	$query="SELECT * FROM Perms WHERE Type='Group' AND ID='".sql_text($groupname)."'";
	$result=mysql_query($query);
	if (mysql_numrows($result)>0) {add_error("Cannot add group, already exists!"); return;}

	$query="INSERT INTO Perms (ID,Description,Type) VALUES ('".
		    sql_text($groupname)."','".sql_text($description)."','Group')";
	mysql_query($query);

	$data_node->new_child("Success");
}

function q_perm_removegroup()
{
	global $question_root,$data_node;	

	if (!perms_superuser()) {add_error("Must be superuser to remove a group."); return;}

	$group_node=find_grandchild($question_root,"Data","Groupname");
	if (! group_node) {add_error("Data/Groupname node not supplied."); return;}
	$groupname=get_text($group_node);
	if (strlen($groupname)==0) {add_error("Groupname is blank!"); return;}

	$query="SELECT * FROM Perms WHERE Type='Group' AND ID='".sql_text($groupname)."'";
	$result=mysql_query($query);
	if (mysql_numrows($result)==0) {add_error("Group does not exist."); return;}
	
	$query="DELETE FROM Perms WHERE (Type='Group' OR Type='Member') AND ID='".sql_text($groupname)."'";
	mysql_query($query);

	$data_node->new_child("Success");
}

?>
