<?php

## Tree/Data Functions
##
## Handles the questions which pertain to direct manipulation
## of data in the Tree and Data tables. This covers most of the 
## routine useage of Xortoth.

function q_wakeup()
{
	add_error("Not implemented.");
}

function q_shutdown()
{
	add_error("Not implemented.");
}


function q_ping()
{
	add_error("Not implemented.");
}

function q_hardreload()
{
	add_error("Not implemented.");
}

function q_tree()
{
	global $question_root,$data_node;

	$path_node=find_grandchild($question_root,"Data","Path");
	if (!$path_node) {add_error("Data/Path node not supplied."); return;}
	$path=get_text($path_node);

	$parent_key=find_tree_path($path);

	if ($parent_key>0)
	{
		$query="SELECT * FROM Tree WHERE Key_Parent=$parent_key ORDER BY Type,Name";
		$result=mysql_query($query);
		$num=mysql_numrows($result);

		for($n=0;$n<$num;$n++)
		{
			$type=mysql_result($result,$n,"Type");
			$name=mysql_result($result,$n,"Name");
			$key=mysql_result($result,$n,"Key_Tree");

			$node=$data_node->new_child($type,"");
			$node->set_attribute("ID",$name);

			$has_children=FALSE;

			$chquery="SELECT Key_Tree FROM Tree WHERE Key_Parent=$key";
			$chresult=mysql_query($chquery);
			if ($num>0) $has_children=TRUE;
			else
			{
				$chquery="SELECT Key_Data FROM Data WHERE Key_Parent=$key";
				$chresult=mysql_query($chquery);
				if ($num>0) $has_children=TRUE;
			}

			if ($has_children) $node->new_child("NotLoaded");
		}

		$query="SELECT * FROM Data WHERE Key_Parent=$parent_key ORDER BY Type,Name";
		$result=mysql_query($query);
		$num=mysql_numrows($result);

		for($n=0;$n<$num;$n++)
		{
			$type=mysql_result($result,$n,"Type");
			$name=mysql_result($result,$n,"Name");

			$node=$data_node->new_child("Property","");
			$node->set_attribute("ID",$name);
			$node->set_attribute("Type",$type);
		}
	}
	else
	{
		add_error("Unable to locate the supplied path [$path].");
	}
}

function q_data()
{
	global $question_root,$data_node;

	$path_node=find_grandchild($question_root,"Data","Path");
	if (!$path_node) {add_error("Data/Path node not supplied."); return;}
	$path=get_text($path_node);

	$key_data=find_data_path($path);
	if ($key_data>0)
	{		
		$query="SELECT Type,Content FROM Data WHERE Key_Data=$key_data";
		$result=mysql_query($query);
		if (mysql_numrows($result)>0)
		{
			$prid_node=$data_node->new_child("ID","");
			$prid_node->new_child("Path",$path);
			$prid_node->new_child("Type",mysql_result($result,0,"Type"));

			$content_text=mysql_result($result,0,"Content");
			## is this necessary? ## $content_text=ereg_replace("\|\|","\n",$content_text);
			$content=domxml_open_mem($content_text);
			$content_root=$content->document_element();
			$data_node->append_child($content_root);
		}
	}
	else
	{
		add_error("Unable to locate the supplied path [$path].");
	}		
}

function q_submit()
{
	global $question_root,$data_node;

	$id_node=find_grandchild($question_root,"Data","ID");
	if (!$id_node) {add_error("Data/Path node not supplied."); return;}
	$path_node=find_child($id_node,"Path");
	if (!$path_node) {add_error("Data/Path node not supplied."); return;}
	$path=get_text($path_node);

	$content_node=$id_node->next_sibling();
	while ($content_node)
	{
		if ($content_node->node_type()==XML_ELEMENT_NODE && $content_node->node_name()!="Type") break;
		$content_node=$content_node->next_sibling();
	}
	if (!$content_node) {add_error("No content node was supplied for submission."); return;}

	$key_data=find_data_path($path);
	if ($key_data>0)
	{
		$content_text=$content_node->dump_node($content_node);
		$content_text=ereg_replace("\r","",$content_text);
		$content_text=ereg_replace("\'","''",$content_text);
		## is this necessary? ## $content_text=ereg_replace("\n","\|\|",$content_text);

		mysql_query("LOCK TABLES Data WRITE");
		$query="UPDATE Data SET Content='$content_text' WHERE Key_Data=$key_data";
		mysql_query($query);
		mysql_query("UNLOCK TABLES Data");

		$data_node->new_child("Path",$path);
	}
	else
	{
		add_error("Unable to locate the supplied path [$path].");
	}		
}

function q_new_container()
{
	new_tree("Container");
}

function q_new_object()
{
	new_tree("Object");
}

function q_new_collection()
{
	new_tree("Collection");
}

function new_tree($type)
{
	global $question_root,$data_node;

	$path_node=find_grandchild($question_root,"Data","Path");
	if (!$path_node) {add_error("Data/Path node not supplied."); return;}
	$path_text=get_text($path_node);
	$name_node=find_grandchild($question_root,"Data","Name");
	if (!$name_node) {add_error("Data/Name node not supplied."); return;}
	$name_text=clean_text(get_text($name_node));

	$key_tree=find_tree_path($path_text);
	if ($key_tree>0)
	{
		$query="SELECT 1 FROM Tree WHERE Key_Parent=$key_tree AND Name='$name_text'";
		$result=mysql_query($query);
		if (mysql_numrows($result)>0)
		{
			add_error("$type already exists: [$name_text] at [$path_text]");
		}
		else
		{
			$query="INSERT INTO Tree (Type,Name,Key_Tree,Key_Parent) VALUES ('$type','$name_text',NULL,$key_tree)";
			mysql_query($query);
		}
	}
	else
	{
		add_error("Unable to locate the supplied path [$path_text].");
	}
}

function q_new_property()
{
	global $question_root,$data_node;

	$path_node=find_grandchild($question_root,"Data","Path");
	if (!$path_node) {add_error("Data/Path node not supplied."); return;}
	$path_text=get_text($path_node);
	$name_node=find_grandchild($question_root,"Data","Name");
	if (!$name_node) {add_error("Data/Name node not supplied."); return;}
	$name_text=clean_text(get_text($name_node));
	$type_node=find_grandchild($question_root,"Data","Type");
	if (!$type_node) {add_error("Data/Type node not supplied."); return;}
	$type_text=get_text($type_node);

	$key_tree=find_tree_path($path_text);
	if ($key_tree>0)
	{
		$query="SELECT 1 FROM Data WHERE Key_Parent=$key_tree AND Name='$name_text'";
		$result=mysql_query($query);
		if (mysql_numrows($result)>0)
		{
			add_error("Property already exists: [$name_text] at [$path_text]");
		}
		else
		{
			$query="INSERT INTO Data (Type,Name,Content,Key_Data,Key_Parent) VALUES ('$type_text','$name_text','<Data/>',NULL,$key_tree)";
			mysql_query($query);
		}
	}
	else
	{
		add_error("Unable to locate the supplied path [$path_text].");
	}
}

function q_delete()
{
	global $question_root,$data_node;

	$path_node=find_grandchild($question_root,"Data","Path");
	if (!$path_node) {add_error("Data/Path node not supplied."); return;}
	$path_text=get_text($path_node);

	$key_data=find_data_path($path_text);
	if ($key_data>0)
	{
		$query="DELETE FROM Data WHERE Key_Data=$key_data";
		mysql_query($query);

		$data_node->new_child("Path",$path_text);
	}
	else
	{
		$key_tree=find_tree_path($path_text);
		if ($key_tree>0)
		{
			delete_tree($key_tree);

			$data_node->new_child("Path",$path_text);
		}
		else
		{
			add_error("Unable to locate the supplied path [$path_text].");
		}
	}
}

	function delete_tree($key_tree)
	{
		$sub_count=0;

		# first delete any and all data records
		$query="DELETE FROM Data WHERE Key_Parent=$key_tree";
		mysql_query($query);

		# now undergo recursive behavior for the tree records
		$query="SELECT Key_Tree FROM Tree WHERE Key_Parent=$key_tree";
		$result=mysql_query($query);

		for($n=0;$n<mysql_numrows($result);$n++)
		{
			$sub_key=mysql_result($result,$n,"Key_Tree");
			delete_tree($sub_key);
		}

		# tree record now presumed empty, so may delete
		$query="DELETE FROM Tree WHERE Key_Tree=$key_tree";
		mysql_query($query);
	}

function q_rename()
{
	global $question_root,$data_node;

	$path_node=find_grandchild($question_root,"Data","Path");
	if (!$path_node) {add_error("Data/Path node not supplied."); return;}
	$path_text=get_text($path_node);
	$name_node=find_grandchild($question_root,"Data","Name");
	if (!$name_node) {add_error("Data/Name node not supplied."); return;}
	$name_text=clean_text(get_text($name_node));

	$key_data=find_data_path($path_text);
	if ($key_data>0)
	{
		$query="SELECT Key_Parent FROM Data WHERE Key_Data=$key_data";
		$result=mysql_query($query);
		$key_parent=mysql_result($result,0,"Key_Parent");
		$query="SELECT 1 FROM Data WHERE Key_Parent=$key_parent AND Name='$name_text'";
		$result=mysql_query($query);
		if (mysql_numrows($result)>0)
		{
			add_error("New name of Property already exists: [$name_text] from [$path_text]");
		}
		else
		{
			mysql_query("LOCK TABLES Data WRITE");
			$query="UPDATE Data SET Name='$name_text' WHERE Key_Data=$key_data";
			mysql_query($query);
			mysql_query("UNLOCK TABLES Data");
		}
	}
	else
	{
		$key_tree=find_tree_path($path_text);
		if ($key_tree>0)
		{
			$query="SELECT Key_Parent FROM Tree WHERE Key_Tree=$key_tree";
			$result=mysql_query($query);
			$key_parent=mysql_result($result,0,"Key_Parent");
			$query="SELECT 1 FROM Tree WHERE Key_Parent=$key_parent AND Name='$name_text'";
			$result=mysql_query($query);
			if (mysql_numrows($result)>0)
			{
				add_error("New name already exists: [$name_text] from [$path_text]");
			}
			else
			{
				mysql_query("LOCK TABLES Tree WRITE");
				$query="UPDATE Tree SET Name='$name_text' WHERE Key_Tree=$key_tree";
				mysql_query($query);
				mysql_query("UNLOCK TABLES Data");
			}
		}
		else
		{
			add_error("Unable to locate the supplied path [$path_text].");
		}
	}
}

function q_fetchbranch()
{
	global $question_root,$data_node;

	$path_node=find_grandchild($question_root,"Data","Path");
	if (!$path_node) {add_error("Data/Path node not supplied."); return;}
	$path_text=get_text($path_node);

	$key_tree=find_tree_path($path_text);
	if ($key_tree==0)
	{
		add_error("Unable to locate the supplied path [$path_text].");
		return;
	}

	recursive_fetch($key_tree,$data_node);
}

	function recursive_fetch($key_tree,$data_node)
	{
		$query="SELECT Type,Name FROM Tree WHERE Key_Tree=$key_tree";
		$result=mysql_query($query);
		if (mysql_numrows($result)<1) return;
		$type=mysql_result($result,0,"Type");
		if ($type=="Realm" || $type=="Container") return;
		$name=mysql_result($result,0,"Name");

		$new_node=$data_node->new_child($type,"");
		$new_node->set_attribute("ID",$name);

		$query="SELECT Key_Tree FROM Tree WHERE Key_Parent=$key_tree";
		$result=mysql_query($query);
		for($n=0;$n<mysql_numrows($result);$n++)
		{
			$key_child=mysql_result($result,$n,"Key_Tree");
			recursive_fetch($key_child,$new_node);
		}

		$query="SELECT Type,Name,Content FROM Data WHERE Key_Parent=$key_tree";
		$result=mysql_query($query);
		for($n=0;$n<mysql_numrows($result);$n++)
		{
			$prop_type=mysql_result($result,$n,"Type");
			$prop_name=mysql_result($result,$n,"Name");
			$prop_content=mysql_result($result,$n,"Content");

			$prop_node=$new_node->new_child("Property","");
			$prop_node->set_attribute("ID",$prop_name);
			$prop_node->set_attribute("Type",$prop_type);
			$prop_data=$prop_node->new_child("Data","");

			$content=domxml_open_mem($prop_content);
			$content_root=$content->document_element();
			$prop_data->append_child($content_root);				
		}
	}

function q_appendbranch()
{
	global $question_root,$data_node;

	$path_node=find_grandchild($question_root,"Data","Path");
	if (!$path_node) {add_error("Data/Path node not supplied."); return;}
	$path_text=get_text($path_node);

	$content_node=find_grandchild($question_root,"Data","Object");
	if (!$content_node) $content_node=find_grandchild($question_root,"Data","Collection");
	if (!$content_node) {add_error("No content provided."); return;}

	$key_tree=find_tree_path($path_text);
	if ($key_tree==0)
	{
		add_error("Unable to locate the supplied path [$path_text].");
		return;
	}

	recursive_append($key_tree,$content_node);
}

	function recursive_append($key_tree,$content_node)
	{
		$type=$content_node->node_name();
		$name=$content_node->get_attribute("ID");

		$query="SELECT Name FROM Tree WHERE Key_Parent=$key_tree AND Name='$name'";
		$result=mysql_query($query);
		if (mysql_numrows($result)>0) {add_error("Tree item with ID [$name] already exists."); return;}
		$query="SELECT Name FROM Data WHERE Key_Parent=$key_tree AND Name='$name'";
		$result=mysql_query($query);
		if (mysql_numrows($result)>0) {add_error("Data with ID [$name] already exists."); return;}

		$query="INSERT INTO Tree (Type,Name,Key_Tree,Key_Parent) VALUES ('$type','$name',NULL,$key_tree)";
		mysql_query($query);
		$key_new=mysql_insert_id();

		$sub_node=$content_node->first_child();
		while ($sub_node)
		{
			if ($sub_node->node_name()=="Object" || $sub_node->node_name()=="Collection")
			{
				recursive_append($key_new,$sub_node);
			}
			else if ($sub_node->node_name()=="Property")
			{
				$prop_type=$sub_node->get_attribute("Type");
				$prop_name=$sub_node->get_attribute("ID");

				$content_node=find_child($sub_node,"Data");
				if ($content_node)
				{
					$content_node=$content_node->first_child();
					while ($content_node)
					{
						if ($content_node->node_type()==XML_ELEMENT_NODE) break;
						$content_node=$content_node->next_sibling();
					}

					if ($content_node)
					{
						$content_text=$content_node->dump_node($content_node);
						$content_text=ereg_replace("\r","",$content_text);
						$content_text=ereg_replace("\'","''",$content_text);

						$query="INSERT INTO Data (Type,Name,Key_Data,Key_Parent,Content) VALUES ('$prop_type','$prop_name',NULL,$key_new,'$content_text')";
						mysql_query($query);
					}
				}
			}
			$sub_node=$sub_node->next_sibling();
		}

	}



?>
